14

这个问题是在面试中提出的,涉及递归/回溯。假设我们有两个布尔数组:bool* source并且bool* target,它们中的每一个都具有相同的长度n(源/目标/n 作为参数给出)。问题的目标是转换sourcetarget使用操作 开关

  • 如果有多个转换:呈现其中任何一个
  • 如果没有解决方案:断言没有解决方案

定义:运算switch(int i, bool* arr)反转 arr[i] 和 arr[i-1] 和 arr[i+1] 的值(如果这些索引在 0...n-1 范围内)。

换句话说,switch操作通常会翻转三位(i和它的邻居),但只有两位。

例如:

  • switch(0,arr) 将只切换 arr[0] 和 arr[1] 的值
  • switch(n-1,arr) 将只切换 arr[n-1] 和 arr[n-2] 的值

提前感谢您对算法的建议。

4

3 回答 3

5

使用回溯,您可以获得 O(n) 解决方案。为什么?

  1. 在单个索引处,您最多只有一个开关
  2. 索引处的 Swicth 只能更改自己和两个邻居。

从左边开始向右移动和回溯是最好的方法。

在任何时候,您最多只能向后退两步。例如,如果您位于索引 n,则只能更改索引 n-1,但不能更改索引 n-2,并且一次或更准确地说,当您到达索引 n+2 时,您只需检查索引 n。

您最多可以有两种解决方案。

解决方案(在python中)

def light(arr,n):
    for i in range(max([0,n-1]),min([len(arr),n+2])):
        arr[i] = not arr[i]
    return arr

goal = [True]*500
def trackback(arr,index,moves):
    if index == len(arr):
        if arr == goal:
            print(moves)
        return

    if index > 1:
        if arr[index-2] != goal[index-2]:
            return
    #print(arr,index,moves)
    #do not make switch
    trackback(arr,index+1,moves)
    #make switch
    moves=moves+[index]
    arr=light(arr,index)
    trackback(arr,index+1,moves)
    arr=light(arr,index) #undo move


arr=[False]*500
trackback(arr,0,[])

输出

[1, 4, 7, 10, 13, 16, 19, 22, 25, 28, 31, 34, 37, 40, 43, 46, 49, 52, 55, 58, 61, 64, 67, 70, 73, 76, 79, 82, 85, 88, 91, 94, 97, 100, 103, 106, 109, 112, 115, 118, 121, 124, 127, 130, 133, 136, 139, 142, 145, 148, 151, 154, 157, 160, 163, 166, 169, 172, 175, 178, 181, 184, 187, 190, 193, 196, 199, 202, 205, 208, 211, 214, 217, 220, 223, 226, 229, 232, 235, 238, 241, 244, 247, 250, 253, 256, 259, 262, 265, 268, 271, 274, 277, 280, 283, 286, 289, 292, 295, 298, 301, 304, 307, 310, 313, 316, 319, 322, 325, 328, 331, 334, 337, 340, 343, 346, 349, 352, 355, 358, 361, 364, 367, 370, 373, 376, 379, 382, 385, 388, 391, 394, 397, 400, 403, 406, 409, 412, 415, 418, 421, 424, 427, 430, 433, 436, 439, 442, 445, 448, 451, 454, 457, 460, 463, 466, 469, 472, 475, 478, 481, 484, 487, 490, 493, 496, 499]
[0, 3, 6, 9, 12, 15, 18, 21, 24, 27, 30, 33, 36, 39, 42, 45, 48, 51, 54, 57, 60, 63, 66, 69, 72, 75, 78, 81, 84, 87, 90, 93, 96, 99, 102, 105, 108, 111, 114, 117, 120, 123, 126, 129, 132, 135, 138, 141, 144, 147, 150, 153, 156, 159, 162, 165, 168, 171, 174, 177, 180, 183, 186, 189, 192, 195, 198, 201, 204, 207, 210, 213, 216, 219, 222, 225, 228, 231, 234, 237, 240, 243, 246, 249, 252, 255, 258, 261, 264, 267, 270, 273, 276, 279, 282, 285, 288, 291, 294, 297, 300, 303, 306, 309, 312, 315, 318, 321, 324, 327, 330, 333, 336, 339, 342, 345, 348, 351, 354, 357, 360, 363, 366, 369, 372, 375, 378, 381, 384, 387, 390, 393, 396, 399, 402, 405, 408, 411, 414, 417, 420, 423, 426, 429, 432, 435, 438, 441, 444, 447, 450, 453, 456, 459, 462, 465, 468, 471, 474, 477, 480, 483, 486, 489, 492, 495, 498]

您可以看到最简单的解决方案就是运行两个 for 循环。第一个解决方案设置第一个灯/开关,第二个不设置。然后决定所有剩余的切换

#do not switch first light
for i in range(1,len(goal)+1):
    if goal[n-1] != arr[n-1]:
        light(arr,n)
check_solution()

#switch first light
switch(arr,n)
for i in range(1,len(goal)+1):
    if goal[n-1] != arr[n-1]:
        light(arr,n)
check_solution()
于 2011-09-03T11:20:56.843 回答
4

据我了解这个问题,主要观察是我们永远不需要在任何位置执行多个开关。这是因为切换两次与完全不切换是一样的,所以所有偶数开关都相当于 0 开关,所有奇数开关都相当于 1 开关。

另一件事是开关的顺序无关紧要。切换第 i 个和第 i+1 个元素与切换第 i+1 个元素然后切换第 i 个元素相同。最后得到的图案是一样的。

使用这两个观察结果,我们可以简单地尝试将 switch 应用于 n 长度数组的所有可能方法。这可以递归完成(即在索引 i 处进行切换/不在索引 i 处进行切换,然后尝试 i+1)或通过枚举所有 2**nn 位掩码并使用它们来应用切换,直到其中一个创建目标值。

以下是我对解决方案的破解。我已将数组打包成整数并将它们用作位掩码以简化操作。这将打印出需要切换以获取目标数组的索引,并在无法获得目标时打印“Impossible”。

#include <cstdio>

int flip(int mask, int bit){
    return mask^(1<<bit);
}

int switch_(int mask, int index, int n){
    for(int i=-1;i<=+1;i++){
        if ((index+i)>=0 && (index+i)<n) mask=flip(mask,index+i);
    }
    return mask;
}

int apply(int source, int flips, int n){
    int result=source;
    for(int i=0;i<n;i++){
        if (flips&(1<<i)) result=switch_(result,i,n);
    }
    return result;
}

void solve(int source, int target, int n){
    bool found=false;
    int current=0;
    int flips=0;
    for(flips=0;flips<(1<<n) && !found;flips++){
        current=apply(source,flips,n);
        found=(current==target);
    }
    if (found){
        flips--;
        for(int i=0;i<n;i++){
            if (flips&(1<<i)) printf("%d ",n-i-1); //prints the indices in descending order
        }
        printf("\n");
    }
    else{
        printf("Impossible\n");
    }
}

int array2int(int* arr, int n){
    int ret=0;
    for(int i=0;i<n;i++){
        ret<<=1;
        if (arr[i]==1) ret++;
    }
    return ret;
}
int main(){
    int source[]={0,0,0,0};
    int target[]={1,1,1,1};
    int n=4;
    solve(array2int(source,n),array2int(target,n),n);
    return 0;
}
于 2011-09-03T10:54:11.330 回答
1

不需要回溯。

很容易看出,对于 N=3k 和 N=3k+1 (k>0),可以翻转每个单独的位,因此对于这些大小,始终存在解决方案。很容易想出一个,为我们需要翻转的每一位添加解决方案。

对于 3k+2 个元素,只能单独翻转一些位,而其他位则成对翻转。也就是说,我们可以单独翻转第 2、5、8 位……,也可以同时翻转 0、1、3、4、6……中的任意两位。因此,仅当且仅当位置 0、1、3、4、6、8 ......必须翻转的位数为偶数时,该解决方案才存在。同样,很容易为每个位或位对提出一个算法。将它们加起来以获得解决方案。

于 2011-09-04T20:20:18.747 回答